	
(function($) {

	$.fn.accordionGallery = function(settings) {
	
	var componentInited=false;
	
	var _body = $('body');
	var _window = $(window);
	var _doc = $(document);
	
	var isMobile = (/Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent));
	
	var isIE = false,isIEbelow9 = false;
	var ie_check = getInternetExplorerVersion();
	if (ie_check != -1){
		isIE = true;
		if(ie_check < 9)isIEbelow9 = true;
	} 
	
	function getInternetExplorerVersion(){
	 //http://msdn.microsoft.com/en-us/library/ms537509%28v=vs.85%29.aspx
	 //Returns the version of Internet Explorer or a -1 (indicating the use of another browser).
	  var rv = -1; // Return value assumes failure.
	  if (navigator.appName == 'Microsoft Internet Explorer'){
		var ua = navigator.userAgent;
		var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
		if (re.exec(ua) != null){
		  rv = parseFloat( RegExp.$1 );
		}
	  }
	  return rv;
	}
	
	var componentWrapper = $(this);
	
	//**************
	jQuery(window).resize(function() {
		alignComponentInPreview();
	});
	
	function alignComponentInPreview(){
		var w = _window.width();
		var h = _window.height();
		var w1 = componentWrapper.width();
		var h1 = componentWrapper.height();
		
		if(w<=w1){
			componentWrapper.css({
				left:0+'px',
				marginLeft:0+'px'
			});
		}else{
			componentWrapper.css({
				left:50+'%',
				marginLeft:-componentWrapper.width()/2+'px'
			});
		}
		if(!settings.dontAlignHeight){
			if(h<=h1){
				componentWrapper.css({
					top:0+'px',
					marginTop:0+'px'
				});
			}else{
				componentWrapper.css({
					top:50+'%',
					marginTop:-componentWrapper.height()/2+'px'
				});
			}
		}
	}
	alignComponentInPreview();
	//**************
	
	
	var componentPlaylist = componentWrapper.find('.componentPlaylist');
	var componentScrollWrapper = componentWrapper.find('.componentScrollWrapper');
	var mediaPreloader = componentWrapper.find('.mediaPreloader');

	var useControls=settings.useControls;
	var alignSlides = settings.alignSlides;
	var sameSizeSlides=settings.sameSizeSlides;
	var transitionTime=800;//slide transition
	var transitionEase='easeOutQuint';
	var slideshowOn=settings.slideshowOn;
	var slideshowTimeout = settings.slideshowDelay;
	var playlistArr = [];
	var transitionOn=false;
	var playlistLength;
	var slideContentStartTimeoutID; 
	var detailOpened=false;//pp opened
	var useKeyboardNavigation=settings.useKeyboardNavigation;
	var useGlobalDelay = settings.useGlobalDelay;
	var componentOrientation = settings.componentOrientation;
	var scrollOrientation = componentOrientation == 'horizontal' ? 'horizontal' : 'vertical';
	var counter;
	var slideshowDirection=settings.slideshowDirection;
	var componentWidth = parseInt(componentPlaylist.css('width'),10);//
	var componentHeight = parseInt(componentPlaylist.css('height'),10);//
	//console.log(componentWidth,componentHeight);
	var componentSize = componentOrientation == 'horizontal' ? componentWidth : componentHeight;
	var animProp = componentOrientation == 'horizontal' ? 'left' : 'top';
	var visibleItems = settings.visibleItems;
	var totalItems;
	var allSlidesVisible=false;
	var lastHitDiv=null;//for restoring hit on last opened slide
	//scroll
	var scrollContentSize;
	var scrollPaneApi;
	var contentFactorMoveValue;
	var openOnRollover = isMobile ? false : settings.openOnRollover;
	var keepSelection = settings.keepSelection;
	var resetAllTimeoutID;//if keepSelection = false, set playlist size and reinitialize scroll api after timeout so it doesnt execute every slide rollout
	
	//controls
	var componentControls=componentWrapper.find('.componentControls');
	var controls_previous = componentControls.find('.controls_previous');
	var controls_toggle = componentControls.find('.controls_toggle');
	var controls_pause = componentControls.find('.controls_pause');
	var controls_pause2 = componentControls.find('.controls_pause2');
	var controls_play = componentControls.find('.controls_play');
	var controls_play2 = componentControls.find('.controls_play2');
	var controls_next = componentControls.find('.controls_next');
	var controlsToggleSrc = controls_toggle.children('img');
	var toggleBtnHeight = controls_pause2.height();
	//console.log(toggleBtnHeight);
			
	controls_previous.css('cursor', 'pointer');
	controls_toggle.css('cursor', 'pointer');
	controls_next.css('cursor', 'pointer');
	controls_previous.bind('click touchstart MozTouchDown', toggleControls);
	controls_toggle.bind('click touchstart MozTouchDown', toggleControls);
	controls_next.bind('click touchstart MozTouchDown', toggleControls);
	
	controls_play.css('display', 'none');
	controls_pause.css('display', 'none');
	
	if(!slideshowOn){
		controls_play.css('display', 'block');
	}else{
		controls_pause.css('display', 'block');
	}

	var componentHit=false;
	componentWrapper.mouseenter(function(e){       
		//console.log("enter");
		componentHit=true;
		if(slideshowOn) pauseSlideshow();
	}).mouseleave(function(){
		//console.log("leave");
		componentHit=false;
		if(slideshowOn && !detailOpened) resumeSlideshow();
	});
	
	if(useKeyboardNavigation){
		_doc.keyup(function(e){
			if (!e) var e = window.event;
			if(e.cancelBubble) e.cancelBubble = true;
			else if (e.stopPropagation) e.stopPropagation();

			//console.log(event.keyCode);
			var key = e.keyCode;
			if(key == 37) {//left arrow
			    previousSlide();
			} 
			else if(key == 39) {//right arrow
				if(slideshowDirection == 'forward'){
					nextSlide();
				}else{
					forcedNextSlide();
				}
			}
			else if(key == 32) {//space
				toggleSlideshow();
			}
			return false;
		});
	}
	
	setup();
		
	function setup(){	
		//console.log('setup');
	
		var j, div,divSize, i = 0,playlist = componentPlaylist.find("div[class=slide]"), dw, dh, ct, fontMeasure = componentWrapper.find('.fontMeasure'), linkDiv, hitDiv, slide_content;
		playlistLength = playlist.length;
		
		totalItems = playlistLength;
		if(visibleItems > totalItems) visibleItems = totalItems;
		if(visibleItems == totalItems) allSlidesVisible =true;
		
		//get playlist
		playlist.each(function() { 
			//console.log($(this));
			playlistArr.push($(this));
		});
		
		for(i; i <playlistLength; i++){
			
			div = $(playlistArr[i]);
			div.attr('data-id', i);
			
			//set slide dimensions
			if(sameSizeSlides){
				if(componentOrientation == 'horizontal'){
					dw = parseInt(div.css('width'),10);
					div.data('itemSize', dw);
				}else{
					dh = parseInt(div.css('height'),10);
					div.data('itemSize', dh);
				}
			}else{
				if(componentOrientation == 'horizontal'){
					if(div.attr('data-width') != undefined && !isEmpty(div.attr('data-width'))){
						dw = parseInt(div.attr('data-width'),10);
						div.css('width', dw+'px');//different width, height is the same for all
						div.data('itemSize', dw);
					}else{
						alert("Slides are missing 'data-width' attributtes!");
						return; 
					}
				}else{
					if(div.attr('data-height') != undefined && !isEmpty(div.attr('data-height'))){
						dh = parseInt(div.attr('data-height'),10);
						div.css('height', dh+'px');//different height, width is the same for all
						div.data('itemSize', dh);
					}else{
						alert("Slides are missing 'data-height' attributtes!");
						return; 
					}
				}
			}
			
		
			
			
			//attach click to detect pp open
			div.find('a[class=pp_content]').bind('click', function(){
				detailOpened=true;
				if(slideshowOn) pauseSlideshow();
				detailActivated();
				return false;
			});
			
			
			dw = parseInt(div.css('width'),10);
			dh = parseInt(div.css('height'),10);
			
			//check slide link
			if(div.attr('data-link') != undefined && !isEmpty(div.attr('data-link'))){
				//console.log(div.attr('data-link'));
				linkDiv = $("<div />");
				linkDiv.css({
					position: 'absolute',
					left: 0+'px',	
					top: 0+'px',
					width: dw+'px',	
					height: dh+'px',		
					background: '#00ff00',
					opacity:0,
					cursor: 'pointer'
				});
				var link = div.attr('data-link'),target;
				if(div.attr('data-target') != undefined && !isEmpty(div.attr('data-target'))){
					target = div.attr('data-target');
				}else{
					target = '_blank';
				}
				var a = $("<a href="+link+" target="+target+" ></a>"); 
				a.append(linkDiv);
				div.append(a);
			}
			
			if(openOnRollover){
				div.bind('mouseenter', overCategoryItem);
				div.bind('mouseleave', outCategoryItem);
			}else{
				
				//check slide hit on top, only for open on click, not needed for open on rollover 
				if(div.attr('data-preventDefaultOnOpen') != undefined && div.attr('data-preventDefaultOnOpen') == 'true'){
					//console.log(div.attr('data-preventDefaultOnOpen'));
					hitDiv = $("<div />");
					hitDiv.css({
						position: 'absolute',
						left: 0+'px',	
						top: 0+'px',
						width: dw+'px',	
						height: dh+'px',		
						background: '#ff0000',
						opacity:0,
						cursor: 'pointer'
					});
					div.append(hitDiv);
					div.data('preventDefaultOnOpen', hitDiv);
					hitDiv.bind('click touchstart MozTouchDown', openSlideOnClick);
					hitDiv.attr('data-id', i);
				}else{
					div.bind('click touchstart MozTouchDown', openSlideOnClick);
				}
				//console.log(div.data('preventDefaultOnOpen'));
			}
			
			
			//check for slide_content
			if(div.find("div[class=slide_content]").length>0){
				//console.log(i);
				slide_content = div.find("div[class=slide_content]");
				div.data('slideContent', slide_content);
			}
		}
		
		componentScrollWrapper.animate({'opacity': 1},  {duration: 1000, easing: "easeOutSine"});//show playlist
		
		distributeSpace();//counter resets here
		counter=settings.activeItem;
		if(counter > playlistLength-1) counter = playlistLength-1;
	
		if(useControls){
			componentControls.css('opacity', 0);
			componentControls.css('display', 'block');
			componentControls.stop().animate({'opacity': 1}, {duration: 1000, easing: "easeOutSine"});
		}
		
		scrollPaneApi = componentScrollWrapper.jScrollPane().data().jsp;//after componentScrollWrapper size set
		setPlaylistSize();
		componentScrollWrapper.bind('jsp-initialised',function(event, isScrollable){
			//console.log('Handle jsp-initialised', this,'isScrollable=', isScrollable);
		});
		if(scrollOrientation == 'horizontal'){
			componentPlaylist.bind('mousewheel', horizontalMouseWheel);
			componentScrollWrapper.jScrollPane({
				enableKeyboardNavigation:false,
				/*
				//enableKeyboardNavigation: if true (which is default), causes weird glitch when keys are used to change slides.
				to replicate: start with slide 0, slideshow off. Use keys to move 2 slides forward one by one, then click on first slide with mouse to come back, then use keyboard to move forward again (without clicking on body again! (non component)), and glitch happens.
				edit:
				only happens in horizontal?
				*/
				maintainPosition:true,
				/*stickToRight:true,*/
				horizontalDragMinWidth: 60,
				horizontalDragMaxWidth: 70
			});
		}else{
			componentScrollWrapper.jScrollPane({
				enableKeyboardNavigation:false,
				maintainPosition:true,
				/*stickToBottom:true,*/
				verticalDragMinHeight: 60,
				verticalDragMaxHeight: 70
			});
		}
		
		mediaPreloader.css('display','none');
		componentInited=true;
		accordionGalleryReady();
		
		if(slideshowOn){
			if(counter==-1) counter=0;
			openSlide(counter);
		}else{
			if(counter!=-1) openSlide(counter);
		}
	}
	
	function setPlaylistSize(reinitialise){
		//console.log('setPlaylistSize, reinitialise = ', reinitialise);
		if(componentOrientation == 'horizontal'){
			componentPlaylist.css('width',scrollContentSize+'px');
			
			if(counter != -1){
				if(reinitialise) scrollPaneApi.reinitialise();
				
				if(!alignSlides) return;
				if(!contentFactorMoveValue) return;//
				//console.log(contentFactorMoveValue);
				
				var deduct = Math.floor((visibleItems-1)/2);
				//console.log('deduct = ', deduct);
				var x = Math.abs((counter-deduct)*contentFactorMoveValue);
				//console.log('x = ', x);
				
				if(counter < Math.ceil(visibleItems/2)){///align dragger/content to left
					x=0;	
				}/*else if(counter > totalItems - Math.ceil(visibleItems/2)){
				}*/
				//console.log('x = ', x);
				scrollPaneApi.scrollToX(x,true);
			}
		}else{
			componentPlaylist.css('height',scrollContentSize+'px');
			if(counter != -1){
				if(reinitialise) scrollPaneApi.reinitialise();
				
				if(!alignSlides) return;
				if(!contentFactorMoveValue) return;//
				
				var deduct = Math.floor((visibleItems-1)/2);
				//console.log('deduct = ', deduct);
				var y = Math.abs((counter-deduct)*contentFactorMoveValue);
				//console.log('x = ', x);
				
				if(counter < Math.ceil(visibleItems/2)){///align dragger/content to left
					y=0;	
				}/*else if(counter > totalItems - Math.ceil(visibleItems/2)){
				}*/
				//console.log('y = ', y);
				scrollPaneApi.scrollToY(y,true);
			}
		}
	}
	
	function horizontalMouseWheel(event, delta, deltaX, deltaY){
		if(!componentInited || !scrollPaneApi) return;
		var d = delta > 0 ? -1 : 1;//normalize
		if(scrollPaneApi) scrollPaneApi.scrollByX(d * 20);
		return false;
	}
	
	
	
	
	
	
	
	 function openSlideOnClick(e) {
		overCategoryItem(e);
	 }
	
	 function overCategoryItem(e) {
		if(!componentInited) return;
		componentHit = true;
		if(slideshowOn) pauseSlideshow();
		 
		if (!e) var e = window.event;
		if(e.cancelBubble) e.cancelBubble = true;
		else if (e.stopPropagation) e.stopPropagation();
		
		var currentTarget = e.currentTarget;
		var id = $(currentTarget).attr('data-id');
		//console.log(id);
		
	    if(currentTarget.opened) return;
	 	//console.log('overCategoryItem', id);
	 
		hidePreviousSlideData(counter);
		counter=id;
		openSlide(counter);
		
		return false;
	}
	
	 function outCategoryItem(e) {
		if(!componentInited) return; 
		 
		if (!e) var e = window.event;
		if(e.cancelBubble) e.cancelBubble = true;
		else if (e.stopPropagation) e.stopPropagation();
		
		var currentTarget = e.currentTarget;
		var id = $(currentTarget).attr('data-id');
		//console.log('outCategoryItem', id);
		
		if(slideshowOn){
			resumeSlideshow();
		}else{
			if(!keepSelection){
				hidePreviousSlideData(id);
				distributeSpace('tween');
				if(resetAllTimeoutID) clearTimeout(resetAllTimeoutID);
				resetAllTimeoutID = setTimeout(resetAll, transitionTime);
			}
		}
		componentHit = false;
		return false;
	}
	
	function hidePreviousSlideData(id) {
		if(id == -1) return;
		
		beforeSlideChange(id);
		
		if(slideContentStartTimeoutID) clearTimeout(slideContentStartTimeoutID);
		removeSlideContent(id);
	}
	
	function openSlide(j) {
		//console.log('openSlide ', j);
		if(!componentInited) return;
		transitionOn=true;
		resetTimer();

		var item,itemToMove = playlistArr[j],i = 0,newPos,id,size,itemSize,z = 0,p = 0,activeX = 0,prop = {};
		
		//check for hit
		if(lastHitDiv){
			lastHitDiv.css('display','block');
			lastHitDiv=null;	
		}
		if(itemToMove.data('preventDefaultOnOpen')){
			lastHitDiv=itemToMove.data('preventDefaultOnOpen');
			lastHitDiv.css('display','none');	
		}
		
		itemSize = parseInt(itemToMove.data('itemSize'), 10);
		contentFactorMoveValue =( componentSize - itemSize) / (visibleItems - 1);
		scrollContentSize = parseInt((itemSize + (contentFactorMoveValue * (totalItems-1))), 10);
		//console.log('contentFactorMoveValue = ', contentFactorMoveValue );
		
		for(i; i< playlistLength; i++) {
				
			item = $(playlistArr[i]);
			id = item.attr('data-id');
			
			if(i < j){//before
				
				newPos = p * contentFactorMoveValue;
				//console.log('before ', i, ' ', newPos);
				prop[animProp] = newPos + 'px';
				
				item.stop().animate(prop,  {duration: transitionTime, easing: transitionEase});
				
				p++;
				
				if(item.attr('data-id') != j){
					item[0].opened = false;
				}else{
					item[0].opened = true;
				}
				
			}
			else if(i == j)	{//active
				
				activeX = j * contentFactorMoveValue;
				//console.log('active ', i, ' ', newPos);
				prop[animProp] = activeX + 'px';
				
				item.stop().animate(prop,  {duration: transitionTime, easing: transitionEase});
				
				if(item.attr('data-id') != j){
					item[0].opened = false;
				}else{
					item[0].opened = true;
				}
				
			}
			else if(i > j)	{//after
				
				newPos = activeX + itemToMove.data('itemSize') + z * contentFactorMoveValue;
				//console.log('after ', i, ' ', newPos);
				prop[animProp] = newPos + 'px';
				
				item.stop().animate(prop,  {duration: transitionTime, easing: transitionEase});
				
				z++;
				
				if(item.attr('data-id') != j){
					item[0].opened = false;
				}else{
					item[0].opened = true;
				}
			}
		}
		
		setPlaylistSize(true);
		
		afterSlideChange(j);
		
		if(slideContentStartTimeoutID) clearTimeout(slideContentStartTimeoutID);
		slideContentStartTimeoutID = setTimeout(function(){checkSlideContent(j)},transitionTime/3);
	}
		
	function distributeSpace(tween) {
		
		var item,i = 0,newPos, prop = {};
		
		scrollContentSize = parseInt((totalItems * (componentSize / visibleItems)), 10);
		var factor = scrollContentSize / totalItems;

		for(i; i< playlistLength; i++) {
			item = $(playlistArr[i]);
			newPos= i * factor;
			//console.log(newPos);
			prop[animProp] = newPos + 'px';
			
			item.stop().animate(prop,  {duration: tween ? transitionTime : 0, easing: transitionEase});
			item[0].opened = false;
		}
		
		/*if(!keepSelection){//fires on every slide change
			if(componentOrientation == 'horizontal'){
				componentPlaylist.css('width',scrollContentSize+'px');
			}else{
				componentPlaylist.css('height',scrollContentSize+'px');
			}
			if(scrollPaneApi) scrollPaneApi.reinitialise();
		}*/
		
		counter=-1;//reset
	}
	
	function resetAll() {//fires on component rollout and distributeSpace finish
		//console.log('resetAll');
		if(resetAllTimeoutID) clearTimeout(resetAllTimeoutID);
		if(componentOrientation == 'horizontal'){
			componentPlaylist.css('width',scrollContentSize+'px');
		}else{
			componentPlaylist.css('height',scrollContentSize+'px');
		}
		if(scrollPaneApi) scrollPaneApi.reinitialise();
	}
	
	//********
	
	function toggleControls(e){
		if(!componentInited) return;
		
		if (!e) var e = window.event;
		if(e.cancelBubble) e.cancelBubble = true;
		else if (e.stopPropagation) e.stopPropagation();
		
		var currentTarget = e.currentTarget;
		var c = $(currentTarget).attr('class');
		
		if(c == 'controls_previous'){
			previousSlide();
		}
		else if(c == 'controls_toggle'){
			toggleSlideshow();
		}
		else if(c == 'controls_next'){
			if(slideshowDirection == 'forward'){
				nextSlide();
			}else{
				forcedNextSlide();
			}
		}
		return false;
	}
	
	function forcedNextSlide(){//if direction backward make 'next slide' forward
		hidePreviousSlideData(counter);
		counter++;
		if(counter>playlistLength - 1) counter=0;//loop
		openSlide(counter);
	}
	
	function nextSlide(){
		hidePreviousSlideData(counter);
		if(slideshowDirection == 'forward'){
			counter++;
			if(counter>playlistLength - 1) counter=0;//loop
		}else{
			counter--;
			if(counter<0) counter=playlistLength - 1;//loop
		}
		openSlide(counter);
	}
	
	function previousSlide(){
		hidePreviousSlideData(counter);
		counter--;
		if(counter<0) counter=playlistLength - 1;//loop
		openSlide(counter);
	}
	
	//find new delay for slide
	function getSlideshowDelay(){
		var nextDelay,reserve= 3000;
		if(useGlobalDelay){
			//console.log('useGlobalDelay');
			nextDelay = slideshowTimeout > 0 ? slideshowTimeout : reserve;
		}else{
			var slide = $(dataArr[counter]);
			if(slide.attr('data-delay') != undefined && !isEmpty(slide.attr('data-width'))){
				nextDelay = slide.attr('data-delay');
				//console.log('nextDelay = ', nextDelay);
			}else{
				alert("You are missing 'data-delay' attribbute in slides, since you are not using global slideshow delay!");
				nextDelay = slideshowTimeout > 0 ? slideshowTimeout : reserve;
			}
		}
		return nextDelay;
	}
	
	this.checkSlideshow2 = function(){//called after prettyphoto detail close (public function)
		detailOpened=false;
		if(slideshowOn){
			controls_play.css('display', 'none');
			controls_pause.css('display', 'block');
			if(!transitionOn){
				resumeSlideshow();
			}
		}	
		detailClosed();
	}
	
	function checkSlideshow(){
		if(slideshowOn && !componentHit){
			var d = getSlideshowDelay();
			controls_pause2.stop().animate( {height: 0+'px'}, {duration: d, easing: 'linear'});
			controls_play2.stop().animate( {height: 0+'px'}, {duration: d, easing: 'linear',complete: nextSlide});
		}
	}
	
	function pauseSlideshow(){
		controls_pause2.stop();
		controls_play2.stop();
		controls_play.css('display', 'block');
		controls_pause.css('display', 'none');
	}
	
	function resumeSlideshow(){
		//console.log('resumeSlideshow');
		//calculate new time
		controls_play.css('display', 'none');
		controls_pause.css('display', 'block');
			
		var h=controls_pause2.height();
		var d = getSlideshowDelay();
		var newTime=h/toggleBtnHeight * d;
		if(newTime < 0) newTime=0;
		//console.log(newTime);
		controls_pause2.stop().animate( {height: 0+'px'}, {duration: newTime, easing: 'linear'});
		controls_play2.stop().animate( {height: 0+'px'}, {duration: newTime, easing: 'linear', complete: nextSlide});
	}
	
	function resetTimer(){
		controls_pause2.stop();
		controls_play2.stop();
		controls_pause2.animate( {height: toggleBtnHeight+'px'}, {duration: 500, easing: 'easeOutExpo' } );
		controls_play2.animate( {height: toggleBtnHeight+'px'}, {duration: 500, easing: 'easeOutExpo' } );
	}
	
	function toggleSlideshow(){
		if(slideshowOn){
			pauseSlideshow();
			slideshowOn = false;
		}else{
			slideshowOn=true;
			controls_play.css('display', 'none');
			controls_pause.css('display', 'block');
			if(!transitionOn){
				resumeSlideshow();
			}
		}	
	}
	
	function toggleSlideshow2(state){
		if(state){//start
			slideshowOn=true;
			controls_play.css('display', 'none');
			controls_pause.css('display', 'block');
			if(!transitionOn){
				resumeSlideshow();
			}
		}else{//stop
			pauseSlideshow();
			slideshowOn = false;
		}
	}
	
	//************** slide content
	
	function removeSlideContent(id){
		if(playlistArr[id].data('slideContent') == undefined) return;
		var slideContent = playlistArr[id].data('slideContent');
		if(slideContent) slideContent.stop().animate({opacity: 0}, {duration: 500, easing: "easeOutSine"});
	}
	
	function checkSlideContent(id){
		//console.log('checkSlideContent');
		if(playlistArr[id].data('slideContent') != undefined){
			
			var slideContent = playlistArr[id].data('slideContent');

			slideContent.stop().animate({opacity: 1}, {
			duration: 500, 
			easing: "easeOutSine",
			complete: function(){
				transitionOn=false;
				checkSlideshow(); 
			}});
			
		}else{
			transitionOn=false;
			checkSlideshow();
		}
	}
	
	//**********  HELPER FUNCTIONS 
	
	function isEmpty(str) {
	    return str.replace(/^\s+|\s+$/g, '').length == 0;
	}
	
	// ******************************** PUBLIC FUNCTIONS **************** //
	
	this.toggleSlideshow = function(state) {
		if(!componentInited) return;
		if(state == undefined){
			toggleSlideshow();
		}else{
			toggleSlideshow2(state);
		}
	}
	
	this.toggleDirection = function(dir) {
		if(!componentInited) return;
		if(!dir || !isEmpty(dir)){
			if(slideshowDirection == 'forward'){
				slideshowDirection = 'backward';	
			}else{
				slideshowDirection = 'forward';	
			}
		}else{
			slideshowDirection = dir;
		}
	}
	
	this.setSlideshowDelay = function(num) {
		if(!componentInited) return;
		slideshowTimeout = num;
	}
	
	this.nextMedia = function() {
		if(!componentInited) return;
		if(slideshowDirection == 'forward'){
			nextSlide();
		}else{
			forcedNextSlide();
		}
	}
	
	this.previousMedia = function() {
		if(!componentInited) return;
		previousSlide();
	}
	
	this.openMedia = function(num) {
		if(!componentInited) return;
		if(num<0)num=0;
		else if(num>playlistLength-1)num=playlistLength-1;
		hidePreviousSlideData(num);
		counter=num;
		openSlide(counter);
	}
	
	return this;

	
	}
	
})(jQuery);


